#-*- coding: utf-8 -*-
import thread2, datetime, time, ffmpegconverter
import urllib, urllib2, gtk, os, shutil, random

class Downloader:
	def __init__(self, pymaxe, url, saveAs, conversionString):
		self.pymaxe = pymaxe
		self.url = url
		self.saveAs = saveAs
		self.gdthread = None
		self.done = False
		self.csize = 0
		self.size = -1
		self.tmp = None
		self.stopDownload = False
		self.downfile = None
		self.converting = False
		self.cvtotal = -1
		self.cvcurrent = -1
		self.ffconvert = None
		self.tagged = False
		self.coverData = None
		if conversionString == 'None':
			self.convert = False
		else:
			self.convert = conversionString

		
	def startDownload(self):
		self.gdthread = thread2.Thread(target=self.goDownload)
		self.gdthread.start()
	
	def goDownload(self):
		selected = None
		details = None
		for x in self.pymaxe.activePlugins:
			for y in self.pymaxe.pluginObj[x].matchurls:
				if y.lower() in self.url.lower():
					selected = x
					break
		retry = 0
		while not details:
			details = self.pymaxe.getDetails(selected, self.url)
			retry += 1
			if retry > 2:
				break
			
		if not details:
			self.size = None
			self.csize = 0
			self.done = None
			return
		now = datetime.datetime.now()
		tmp = str(time.mktime(now.timetuple())) + str(random.randint(1, 999))
		if os.environ.get("APPDATA"):
			self.tmp = os.environ.get('TMP') + '\\' + tmp
		else:
			self.tmp = '/tmp/' + tmp
		self.size = int(details['fsize'])
		downurl = details['downurl']
		conn = self.conn(downurl)
		if not conn:
			self.size = None
			self.csize = 0
			self.done = None
			return
		with open(self.tmp, 'wb') as self.downfile:
			while not self.stopDownload:
				downData = conn.read(1024)
				self.csize = int(os.path.getsize(self.tmp))
				if not downData:
					self.downfile.close()
					if self.convert:
						self.ffconvert = ffmpegconverter.FFConvert(self.tmp, self.saveAs, self.convert)
						self.ffconvert.start()
						self.converting = True
						while not self.ffconvert.done:
							self.cvtotal = self.ffconvert.time_seconds
							self.cvcurrent = self.ffconvert.current
							time.sleep(0.1)
						self.done = True
						errlevel = self.ffconvert.pipe.poll()
						if errlevel:
							self.size = None
						os.remove(self.tmp)
						self.downfile.close()
					else:
						shutil.copyfile(self.tmp, self.saveAs)
						os.remove(self.tmp)
						self.downfile.close()
						self.done = True
					break
				self.downfile.write(downData)
	
	def conn(self, downurl, retry = 0):
		conn = None
		try:
			conn = urllib2.urlopen(downurl)
		except:
			retry += 1
			if retry < 2:
				conn = self.conn(downurl, retry)
			else:
				return None
		return conn
	
	def saveCover(self, data):
		self.coverData = data
		
	def cancel(self):
		self.stopDownload = True
		if self.gdthread:
			if self.gdthread.isAlive():
				if self.downfile:
					if not self.downfile.closed:
						self.downfile.close()
				self.gdthread.terminate()
		if self.converting:
			if self.ffconvert:
				self.ffconvert.cancel()
		if self.tmp:
			if os.path.exists(self.tmp):
				os.remove(self.tmp)
		
		