#!/usr/bin/python2
#-*- coding: utf-8 -*-
version = '0.50.3'

import sys, os
path = os.getcwd()
if os.environ.get("APPDATA"):
	if os.path.exists(os.environ.get("APPDATA") + '\\roxe\\app\\lib.zip'):
		# if we ever need to update Python's libraries
		sys.path.insert(0, os.environ.get("APPDATA") + '\\roxe\\app\\lib.zip')
	osystem = 'WIN'
	userpath = os.environ.get("APPDATA")
else:
	osystem = 'UNX'
	userpath = os.environ.get("HOME")
import thread2, subprocess, webbrowser, socket, urllib, gtk, gobject, pango, configure, random, time, datetime
import tools, searcher, details, coverFinder, mediaPlayer, errorManager
import settingsManager, downloader, album, albumDownloader, eyeD3
from tools import label_set_autowrap
import libpymaxe
Pymaxe = libpymaxe.Pymaxe()

if not '--debug' in sys.argv:
	ErrorManager = errorManager.ErrorManager()
	sys.excepthook = ErrorManager._error
	libpymaxe.extras.output_exc = ErrorManager.exception
else:
	print "Starting Pymaxe in debug mode"
if '--portable' in sys.argv:
	userpath = os.getcwd()

os.chdir(path)
AUDIO_FILE = 0x01
VIDEO_FILE = 0x02
AUDIO_FILE_ICON = gtk.gdk.pixbuf_new_from_file('audio-x-wav.png')
VIDEO_FILE_ICON = gtk.gdk.pixbuf_new_from_file('video-x-generic.png')
ALBUM_FILE_ICON = gtk.gdk.pixbuf_new_from_file('tools-rip-audio-cd.png')
	
if osystem == 'WIN':
	if not '--debug' in sys.argv:
		sys.stdout = open(userpath + '/pymaxe.log', 'w')
		sys.stderr = open(userpath + '/pymaxe.log', 'w')

gtk.gdk.threads_init()

class Main:
	def __init__(self):
		self.gui = gtk.Builder()
		self.gui.add_from_file('pymaxe.glade')
		label_set_autowrap(self.gui.get_object('label3'))
		self.gui.get_object('treeviewcolumn2').clicked()
		self.gui.get_object('treemodelfilter1').set_visible_func(self.filterTree)
		self.gui.get_object('treemodelfilter1').set_modify_func(['GdkPixbuf', str, str, str], self.modify_func)
		self.gui.get_object('statusImage').set_from_file('load.png')
		self.gui.connect_signals({
			"on_mainw_destroy_event" : self.quit,
			"showAbout" : self.showAbout,
			"hideAbout" : self.hideAbout,
			"doSearch" : self.doSearch,
			"changeFilter" : self.changeFilter,
			"selectSong" : self.selectSong,
			"playSong" : self.playSong,
			"stopSong" : self.stopSong,
			"changeVolume" : self.changeVolume,
			"seekSong" : self.seekSong,
			"openSourcePage" : self.openSourcePage,
			"openWithPlayer" : self.openWithPlayer,
			"showSettings" : self.showSettings,
			"donate" : self.donate,
			"fblike" : self.fblike,
			"facebook" : self.facebook,
			"cursorPointer" : self.cursorPointer,
			"cursorNormal" : self.cursorNormal,
			"hoverfb" : self.hoverfb,
			"unhoverfb" : self.unhoverfb,
			"downloadThis" : self.downloadThis,
			"hideFileChooser" : self.hideFileChooser,
			"addDownload" : self.addDownload,
			"updateSaveAs" : self.updateSaveAs,
			"selectDownload" : self.selectDownload,
			"openDownload" : self.openDownload,
			"stopRemoveDownload" : self.stopRemoveDownload,
			"showDebug" : self.showDebug,
			"draw_background" : self.draw_background
			})
		
		self.config = configure.Config()
		self.Search = searcher.PymaxeSearch(Pymaxe, self.populateResults)
		self.Details = details.Details(Pymaxe, self.showDetails)
		self.CoverFind = coverFinder.coverFinder(Pymaxe, self.setCover)
		self.mp = mediaPlayer.mediaPlayer(self.config, self.setAdjustment)
		self.settingsManager = settingsManager.settingsManager(self, Pymaxe, self.config)
		self.Album = album.Album(self.showAlbumDetails)
		self.lastIter = None
		self.fileData = None
		self.loadPlayer = None
		self.downloadUpdater = None
		self.downloaders = {}
		self.lastSaveDir = self.config.getSetting('General', 'download_into_default', self.config.guessDownloadFolder())
		
		self.loadPlugins()
		self.populateFileTypes()
		self.populateFileFormats()
		self.gui.get_object('scalebutton1').set_value(float(self.config.getSetting('General', 'volume', 100.0)))
		self.gui.get_object('combobox2').set_active(0)
		if not self.mp.available:
			self.gui.get_object('frame1').set_sensitive(False)
		if osystem == 'WIN':
			self.gui.get_object('frame1').set_shadow_type(gtk.SHADOW_ETCHED_IN)
		if '--portable' in sys.argv:
			self.gui.get_object('mainw').set_title(self.gui.get_object('mainw').get_title() + ' (portable)')
		self.gui.get_object('cellrenderertext1').props.ellipsize = pango.ELLIPSIZE_END
		self.gui.get_object('cellrenderertext1').props.width = self.gui.get_object('treeviewcolumn2').get_width() - 50
		self.gui.get_object('cellrenderertext5').props.ellipsize = pango.ELLIPSIZE_END
		self.gui.get_object('cellrenderertext5').props.width = self.gui.get_object('treeviewcolumn5').get_width()
		self.gui.get_object('cellrenderertext6').props.ellipsize = pango.ELLIPSIZE_END
		self.gui.get_object('cellrenderertext6').props.width = self.gui.get_object('treeviewcolumn6').get_width()
		self.gui.get_object('cellrendererprogress1').props.width = 150
		self.notifyOpened()
		gtk.gdk.threads_enter()
		gtk.main()
		gtk.gdk.threads_leave()
		#self.settingsManager.displayWindow(False)
		
	def loadPlugins(self):
		if osystem == 'WIN':
			customdir = self.config.getSetting('General', 'pymaxe_plugins_folder', 'C:\\')
		else:
			customdir = self.config.getSetting('General', 'pymaxe_plugins_folder', '/')
		Pymaxe.setPluginsDir(customdir)
		Pymaxe.readPlugins()
		for x in Pymaxe.plugins:
			if not x in self.config.getSetting('General', 'plugins_blacklist', []):
				Pymaxe.loadPlugin(x)
	
	def populateFileTypes(self):
		liststore = self.gui.get_object('combostore')
		liststore.append([gtk.gdk.pixbuf_new_from_file('application-x-sharedlib.png'), 'All', str(0x00)])
		liststore.append([AUDIO_FILE_ICON, 'Music', str(0x01)])
		liststore.append([VIDEO_FILE_ICON, 'Video', str(0x02)])
		liststore.append([ALBUM_FILE_ICON, 'Albums', str(0x03)])
		self.gui.get_object('combobox1').set_active(0)
		
	def populateFileFormats(self):
		liststore = self.gui.get_object('fileFormats')
		liststore.append(['No conversion', 'None', ''])
		liststore.append(['MP3 File', '-b 192k -i INPUT OUTPUT', '.mp3'])
		liststore.append(['AAC File', '-i INPUT -acodec aac -strict experimental -ab 128k OUTPUT', '.aac'])
		liststore.append(['OGG File', '-i INPUT -acodec libvorbis -aq 100 OUTPUT', '.ogg'])
		liststore.append(['AVI File', '-sameq -i INPUT OUTPUT', '.avi'])
		liststore.append(['MPEG File', '-sameq -i INPUT OUTPUT', '.mpg'])
		liststore.append(['MP4 File', '-sameq -i INPUT -vcodec libxvid -strict experimental OUTPUT', '.mp4'])
		liststore.append(['PSP Video', '-i INPUT -b 300 -s 320x240 -vcodec libxvid -strict experimental -ab 32 -ar 24000 -acodec aac OUTPUT', '.mp4'])
		liststore.append(['DVD-Compatible', '-i INPUT -target pal-dvd -ps 2000000000 -aspect 16:9 OUTPUT', '.mpeg'])
	
	def doSearch(self, obj, event=None):
		if event:
			if event.keyval != 65293:
				return
		if self.Search.isSearching:
			self.Search.stop()
			self.setIdle(None, False)
			return
		if self.Details.isRetrieving:
			self.gui.get_object('hbox5').set_sensitive(True)
			self.gui.get_object('hbox13').set_sensitive(True)
			self.gui.get_object('hbox2').set_sensitive(True)
			self.Details.cancel()
			self.setIdle(None, False)
			return
		if self.Album.isRetrieving:
			self.Album.cancel()
			self.setIdle(None, False)
			return
		if len(Pymaxe.activePlugins) == 0:
			self.gui.get_object('statusImage').set_from_file('error.png')
			self.gui.get_object('statusLabel').set_text('No active plugins. Please activate at least one plugin from settings window')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
			self.setIdle(None, False)
			return
		self.gui.get_object('treeview1').grab_focus()
		self.search(self.gui.get_object('entry1').get_text())
	
	def search(self, value):
		if value == '':
			return
		if value.startswith('http://'):
			self.stopSong(None)
			self.gui.get_object('hbox5').set_sensitive(False)
			self.gui.get_object('hbox13').set_sensitive(False)
			self.gui.get_object('hbox2').set_sensitive(False)
			self.setIdle('Getting details...')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_STOP, gtk.ICON_SIZE_MENU)
			thread2.Thread(target=self.loadDefUrl, args=(value, )).start()
			return
		self.gui.get_object('srchstore_data').clear()
		self.gui.get_object('image1').set_from_stock(gtk.STOCK_STOP, gtk.ICON_SIZE_MENU)
		self.setIdle('Searching...', True)
		self.Search.search(value)
	
	def loadDefUrl(self, url):					# load a URL insered by user
		self.Details.downloadData(url, self.insertResult)
		
	def insertResult(self, data):
		model = self.gui.get_object('srchstore_data')
		model.clear()
		if data['type'] == 0x01:
			icon = AUDIO_FILE_ICON
		elif data['type'] == 0x02:
			icon = VIDEO_FILE_ICON
		elif data['type'] == 0x03:
			icon = ALBUM_FILE_ICON
		iter = model.append([icon, data['title'], data['url'], data['length'], data['type']])
		path = model.get_path(iter)
		self.gui.get_object('treeview1').set_cursor(path)
	
	def populateResults(self, data):
		if data == None:
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
			if not self.Details.isRetrieving and not self.Album.isRetrieving:
				self.setIdle(None, False)
			return
		liststore = self.gui.get_object('srchstore_data')
		for x in data:
			if x[0] == 0x01:
				icon = AUDIO_FILE_ICON
			elif x[0] == 0x02:
				icon = VIDEO_FILE_ICON
			elif x[0] == 0x03:
				icon = ALBUM_FILE_ICON
			liststore.append([icon, x[1], x[2], x[3], x[0]])
		
	def selectSong(self, data):
		treeselection = self.gui.get_object('treeview1').get_selection()
		(model, iter) = treeselection.get_selected()
		if self.lastIter == model[iter][2]:
			return
		if self.loadPlayer:
			if self.loadPlayer.isAlive():
				self.loadPlayer.terminate()
		self.stopSong(None)
		self.gui.get_object('hbox5').set_sensitive(False)
		self.gui.get_object('hbox13').set_sensitive(False)
		self.gui.get_object('hbox2').set_sensitive(False)
		self.setIdle('Getting details...')
		self.gui.get_object('image1').set_from_stock(gtk.STOCK_STOP, gtk.ICON_SIZE_MENU)
		self.lastIter = model[iter][2]
		if model[iter][2].startswith('album://'):
			self.Album.details(model[iter][2], self.config.getSetting('General', 'download_covers', True))
			return
		self.Details.getData(model[iter][2])
		
	def showDetails(self, data):
		treeselection = self.gui.get_object('treeview1').get_selection()
		(model, iter) = treeselection.get_selected()
		self.fileData = data
		if not data:
			self.setIdle(None, False)
			self.gui.get_object('statusImage').set_from_file('error.png')
			self.gui.get_object('statusLabel').set_text('Error...')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
			self.gui.get_object('hbox5').set_sensitive(True)
			self.gui.get_object('hbox13').set_sensitive(True)
			self.gui.get_object('hbox2').set_sensitive(True)
			return
		if not data['url'] in model[iter][2]:
			return
		self.gui.get_object('image3').set_from_file('cd_case.png')
		self.ftype = data['type']
		self.gui.get_object('hbox5').set_sensitive(True)
		self.gui.get_object('hbox13').set_sensitive(True)
		self.gui.get_object('hbox2').set_sensitive(True)
		self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
		self.gui.get_object('hbox5').hide()
		self.gui.get_object('hbox13').hide()
		self.CoverFind.abort()
		if self.config.getSetting('General', 'download_covers', True):
			self.CoverFind.searchCover(data['title'])
			self.coverFindJob = data['url']
		if ' - ' in data['title']:
			(artist, title) = data['title'].rsplit(' - ', 1)
			self.gui.get_object('titleLabel').set_text(title)
			self.gui.get_object('artistLabel').set_text(artist)
		else:
			self.gui.get_object('titleLabel').set_text(data['title'])
			self.gui.get_object('artistLabel').set_text('')
		if self.ftype == AUDIO_FILE:
			self.gui.get_object('labelType').set_text('Audio')
		elif self.ftype == VIDEO_FILE:
			self.gui.get_object('labelType').set_text('Video')
		self.gui.get_object('labelSize').set_text(str(data['fsize']) + ' MB')
		self.gui.get_object('labelSource').set_text(data['url'])
		if not self.mp.available:
			self.gui.get_object('hbox3').set_sensitive(False)
		iter = self.gui.get_object('srchstore_data').get_iter_root()
		if not iter:
			if x[0] == 0x01:
				icon = AUDIO_FILE_ICON
			elif x[0] == 0x02:
				icon = VIDEO_FILE_ICON
			self.gui.get_object('srchstore_data').append([icon, data['title'], data['url'], '', x[0]])
		self.gui.get_object('hbox13').hide()
		self.gui.get_object('hbox2').show()
		if not self.Search.isSearching:
			self.setIdle(None, False)
		
	def showAlbumDetails(self, data):
		treeselection = self.gui.get_object('treeview1').get_selection()
		(model, iter) = treeselection.get_selected()
		if not data:
			self.setIdle(None, False)
			self.gui.get_object('statusImage').set_from_file('error.png')
			self.gui.get_object('statusLabel').set_text('Error...')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
			self.gui.get_object('hbox5').set_sensitive(True)
			self.gui.get_object('hbox13').set_sensitive(True)
			self.gui.get_object('hbox2').set_sensitive(True)
			return
		if model[iter][2] != data['url']:
			return
		self.gui.get_object('image12').set_from_file('cd_case.png')
		self.gui.get_object('hbox5').set_sensitive(True)
		self.gui.get_object('hbox13').set_sensitive(True)
		self.gui.get_object('hbox2').set_sensitive(True)
		self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
		self.gui.get_object('hbox5').hide()
		self.gui.get_object('hbox2').hide()
		if hasattr(self, "openalbum_conn"):
			self.gui.get_object('button10').disconnect(self.openalbum_conn)
		if hasattr(self, "downalbum_conn"):
			self.gui.get_object('button9').disconnect(self.downalbum_conn)
		self.openalbum_conn = self.gui.get_object('button10').connect("clicked", self.openAlbumSourcePage, data['url'])
		self.downalbum_conn = self.gui.get_object('button9').connect("clicked", self.downloadAlbum, data)
		self.CoverFind.abort()
		if self.config.getSetting('General', 'download_covers', True):
			self.CoverFind.searchCover(data['name'], data['mbid'])
		self.gui.get_object('albumLabel').set_text(data['name'])
		self.gui.get_object('artistAlbumLabel').set_text(data['artist'])
		self.gui.get_object('labelTracksNo').set_text(data['tracks'])
		self.gui.get_object('labelRelease').set_text(data['release'])
		self.gui.get_object('hbox2').hide()
		self.gui.get_object('hbox13').show()
		self.setIdle(None, False)
		
	def setCover(self, data):
		if not data:
			return
		if hasattr(self, "coverFindJob"):
			treeselection = self.gui.get_object('treeview1').get_selection()
			(model, iter) = treeselection.get_selected()
			url = model[iter][2]
			if self.coverFindJob != url:
				return
		pixbuf = tools.Image_to_GdkPixbuf(data)
		if self.gui.get_object('hbox2').get_visible():
			self.gui.get_object('image3').set_from_pixbuf(pixbuf)
		if self.gui.get_object('hbox13').get_visible():
			self.gui.get_object('image12').set_from_pixbuf(pixbuf)
	
	def playSong(self, obj, event=None):
		if not self.mp.available:
			return
		if self.loadPlayer:
			if self.loadPlayer.isAlive():
				return
			if self.mp.isPlaying():
				self.mp.pause()
				self.gui.get_object('image5').set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_MENU)
			else:
				self.mp.play()
				self.gui.get_object('image5').set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_MENU)
				self.mp.volume(self.gui.get_object('scalebutton1').get_value())
			return
		treeselection = self.gui.get_object('treeview1').get_selection()
		(model, iter) = treeselection.get_selected()
		url = model[iter][2]
		self.loadPlayer = thread2.Thread(target=self.preparePlayer, args=(url,))
		self.loadPlayer.start()
		self.gui.get_object('labelPlayerWait').set_markup('<b>Loading, please wait...</b>')
		self.gui.get_object('labelPlayerWait').show()
	
	def preparePlayer(self, url):
		self.Details.downloadData(url, self.startPlay)
	
	def startPlay(self, data):
		if not data:
			self.gui.get_object('hbox3').set_sensitive(False)
			self.gui.get_object('statusImage').set_from_file('error.png')
			self.gui.get_object('statusLabel').set_text('Error...')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
			return
		self.gui.get_object('labelPlayerWait').set_markup('<b>Buffering...</b>')
		self.gui.get_object('image5').set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_MENU)
		self.mp.volume(self.gui.get_object('scalebutton1').get_value())
		self.mp.load(data['downurl'])
		gobject.timeout_add(500, self.mp.updateAdjustment, True)
		self.mp.play()
			
	def stopSong(self, obj, event=None):
		if not self.mp.available:
			return
		self.loadPlayer = None
		self.mp.unload()
		gobject.timeout_add(500, self.mp.updateAdjustment, False)
		self.gui.get_object('labelET').set_text('00:00')
		self.gui.get_object('labelTT').set_text('00:00')
		self.gui.get_object('adjustment1').set_value(0.0)
		self.gui.get_object('image5').set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_MENU)
		
	def seekSong(self, obj, event=None, value=None):
		if not self.mp.available:
			return
		if event:
			if event.type == gtk.gdk.BUTTON_PRESS:
				self.mp.isSeeking = True
		value = obj.get_value()
		if value > 100:
			value = 100
		if event:
			if event.type == gtk.gdk.BUTTON_RELEASE:
				self.mp.isSeeking = False
				self.mp.seek(value)
				
	def setAdjustment(self, pos, ret):
		self.gui.get_object('labelPlayerWait').hide()
		self.adjustment = self.gui.get_object('adjustment1')
		if pos[0] > 99.0:
			if pos[1] != ' day, 23:59:59':
				self.stopSong(None)
		if not self.mp.isPlaying():
			return False
		if not self.mp.isSeeking:
			self.adjustment.set_value(pos[0])
		self.gui.get_object('labelET').set_text(pos[1])
		self.gui.get_object('labelTT').set_text(pos[2])
		
	def changeVolume(self, obj, value):
		if not self.mp.available:
			return
		self.mp.volume(value)
		self.config.setSetting('General', 'volume', value)
		
	def openSourcePage(self, obj, event=None):
		webpage = self.gui.get_object('labelSource').get_text()
		webbrowser.open(webpage)
		
	def openAlbumSourcePage(self, obj, url):
		webbrowser.open(url)
	
	def openWithPlayer(self, obj, event=None):
		url = self.fileData['downurl']
		ftype = self.fileData['type']
		try:
			if ftype==AUDIO_FILE:
				if osystem == 'WIN':
					command = [self.config.getSetting('General', 'audio_player', tools.getOpenWith('.mp3')[0])]
				else:
					command = [self.config.getSetting('General', 'audio_player', tools.getOpenWith('.mp3')[0])]
			elif ftype==VIDEO_FILE:
				if osystem == 'WIN':
					command = [self.config.getSetting('General', 'video_player', tools.getOpenWith('.mp4')[0])]
				else:
					command = [self.config.getSetting('General', 'video_player', tools.getOpenWith('.mp4')[0])]
			else:
				command = None
			if command:
				command.append(url)
				subprocess.Popen(command)
		except Exception, e:
			print e
			self.gui.get_object('statusImage').set_from_file('error.png')
			self.gui.get_object('statusLabel').set_text('Cannot open: no application associated with this file type.')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
	
	def showSettings(self, obj, event=None):
		self.settingsManager.displayWindow()
		
	def changeFilter(self, obj, event=None):
		self.gui.get_object('treemodelfilter1').refilter()
			
	def filterTree(self, model, iter):
		combo = self.gui.get_object('combobox1')
		cmodel = combo.get_model()
		index = combo.get_active()
		active = cmodel[index][2]
		if active == str(0x00):
			return True
		if model[iter][4] == active:
			return True
		
	def modify_func(self, model, iter, col, attrs):
		child_model_iter = model.convert_iter_to_child_iter(iter)
		child_model = model.get_model()
		row_obj = child_model.get_value(child_model_iter, 0)

		path = child_model.get_path(child_model_iter)
		path_str=  "-".join(str(i) for i in path)

		if col == 1: #first column
			arr = self.row[path_str][col]
		elif col == 2:
			arr = self.row[path_str][col]
		elif col == 3:
			arr = self.row[path_str][col]
		else:
			arr = "faszomat"
		return arr
	
	def setIdle(self, text='Idle...', activate=True):
		if activate:
			self.gui.get_object('statusImage').set_from_animation(gtk.gdk.PixbufAnimation('load.gif'))
			self.gui.get_object('statusLabel').set_text(text)
		else:
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
			self.gui.get_object('statusImage').set_from_file('load.png')
			self.gui.get_object('statusLabel').set_text('Idle...')
			
	def downloadAlbum(self, obj, data):
		dfolder = self.config.getSetting('General', 'download_into_default', self.config.guessDownloadFolder())
		downloader = albumDownloader.AlbumDownloader(Pymaxe, self.Album, data, self.startDownload)
		downloader.gui.get_object('label4').set_text(dfolder)
		if not self.config.getSetting('General', 'download_covers', True):
			downloader.gui.get_object('checkbutton1').set_active(False)
		downloader.show()
	
	def downloadThis(self, obj, event=None):
		artist = self.gui.get_object('artistLabel').get_text()
		title = self.gui.get_object('titleLabel').get_text()
		if (artist == ''):
			titlu = title
		else:
			titlu = artist + ' - ' + title
		if self.ftype == AUDIO_FILE:
			ext = '.mp3'
		elif self.ftype == VIDEO_FILE:
			ext = '.avi'
		fchooser = self.gui.get_object("filechooserdialog1")
		fchooser.set_local_only(True)
		if osystem == 'WIN':
			fchooser.set_current_name(tools.strip_win32_incompat(titlu + ext))
		else:
			fchooser.set_current_name(titlu + ext)
		fchooser.set_current_folder(self.lastSaveDir)
		self.gui.get_object('combobox2').emit("changed")
		fchooser.show()
		
	def addDownload(self, obj):
		self.lastSaveDir = self.gui.get_object("filechooserdialog1").get_current_folder()
		filename = self.gui.get_object("filechooserdialog1").get_filename()
		if os.path.exists(filename):
			ovrw = tools.msg_warning('This file already exists. It\'s ok to overwrite?')
			if ovrw == gtk.RESPONSE_CANCEL:
				return
		self.hideFileChooser()
		artist = self.gui.get_object('artistLabel').get_text()
		title = self.gui.get_object('titleLabel').get_text()
		source = self.gui.get_object('labelSource').get_text()
		if (artist == ''):
			titlu = title
		else:
			titlu = artist + ' - ' + title
		if osystem == 'WIN':
			path, filename = os.path.split(filename)
			saveAs = path + '/' + tools.strip_win32_incompat(filename)
		else:
			saveAs = filename
		self.startDownload(titlu, source, saveAs)
	
	def startDownload(self, titlu, source, saveAs):
		jobID = source + '___' + str(random.randint(1, 999))
		model = self.gui.get_object('combobox2').get_model()
		iter = self.gui.get_object('combobox2').get_active_iter()
		conversionString = model[iter][1]
		self.downloaders[jobID] = downloader.Downloader(Pymaxe, source, saveAs, conversionString)
		img = gtk.gdk.pixbuf_new_from_file('wait.png')
		coverfind = coverFinder.coverFinder(Pymaxe, self.downloaders[jobID].saveCover)
		coverfind.searchCover(titlu)
		self.gui.get_object('downloadStore').append([img, titlu, saveAs, 0, jobID])
		self.downloaders[jobID].startDownload()
		if not self.downloadUpdater:
			self.downloadUpdater = gobject.timeout_add(500, self.updateDownloads)
	
	def hideFileChooser(self, obj=None, event=None):
		self.gui.get_object("filechooserdialog1").hide()
		return True
		
	def updateSaveAs(self, obj, event=None):
		fchooser = self.gui.get_object("filechooserdialog1")
		fname = fchooser.get_filename()
		if not fname:
			return
		fname = os.path.basename(fname)
		fname = os.path.splitext(fname)
		actual = fname[0]
		model = obj.get_model()
		iter = obj.get_active_iter()
		ext = model[iter][2]
		if ext == '':
			if self.ftype == AUDIO_FILE:
				ext = '.mp3'
			elif self.ftype == VIDEO_FILE:
				ext = '.avi'
		fchooser.set_current_name(actual + ext)
		
	def updateDownloads(self):
		actives = 0
		downloadStore = self.gui.get_object('downloadStore')
		iter = downloadStore.get_iter_root()
		if not iter:
			return True
		while iter:
			jobID = downloadStore[iter][4]
			downloader = self.downloaders[jobID]
			if not downloader.stopDownload:
				if not downloader.done:
					if downloader.size:
						actives += 1
				self.tsize = downloader.size
				if downloader.convert:
					if downloader.converting:
						if downloader.cvcurrent:
							if downloader.cvtotal:
								procent = ((float(downloader.cvcurrent/2) / float(downloader.cvtotal)) * 100) + 50
							else:
								downloadStore = self.gui.get_object('downloadStore')
								procent = downloadStore.get_value(iter, 3)
							if downloader.done:
								procent = 100
							self.downloadProgress(procent, downloader.done, iter)
					else:
						if downloader.csize:
							procent = (float(downloader.csize) / float(downloader.size*2)) * 100
						else:
							procent = 0
						if downloader.done:
							procent = 100
						self.downloadProgress(procent, downloader.done, iter)
				else:
					if downloader.csize:
						procent = (float(downloader.csize) / float(downloader.size)) * 100
					else:
						procent = 0
					if downloader.done:
						procent = 100
					self.downloadProgress(procent, downloader.done, iter)
			iter = downloadStore.iter_next(iter)
		if actives > 0:
			self.gui.get_object('label2').set_text('Downloads (' + str(actives) + ')')
		else:
			self.gui.get_object('label2').set_text('Downloads')
		self.selectDownload()
		return True
		
	def downloadProgress(self, procent, done, iter):
		downloadStore = self.gui.get_object('downloadStore')
		if not self.tsize:
			downloadStore.set_value(iter, 0, gtk.gdk.pixbuf_new_from_file('error.png'))
			downloadStore.set_value(iter, 3, 0)
			return
		if done:
			downloadStore.set_value(iter, 0, gtk.gdk.pixbuf_new_from_file('ok.png'))
			downloadStore.set_value(iter, 3, 100)
			jobID = downloadStore[iter][4]
			if not self.downloaders[jobID].tagged:
				self.setTags(downloadStore[iter][1], downloadStore[iter][2], self.downloaders[jobID])
				if self.config.getSetting('General', 'opendownloaded', False):
					self.openDownload(None, self.downloaders[jobID].saveAs)
				self.downloaders[jobID].tagged = True
		else:
			downloadStore.set_value(iter, 0, gtk.gdk.pixbuf_new_from_file('download2.png'))
			downloadStore.set_value(iter, 3, procent)
			
	def selectDownload(self, obj=None, event=None):
		treeselection = self.gui.get_object('treeview2').get_selection()
		(model, iter) = treeselection.get_selected()
		if not iter:
			self.gui.get_object('toolbutton2').set_sensitive(False)
			self.gui.get_object('toolbutton1').set_sensitive(False)
			return
		jobID = model[iter][4]
		downloader = self.downloaders[jobID]
		if downloader.done == True:
			if os.path.exists(downloader.saveAs):
				self.gui.get_object('toolbutton1').set_sensitive(True)
			else:
				self.gui.get_object('toolbutton1').set_sensitive(False)
			self.gui.get_object('toolbutton2').set_sensitive(True)
			self.gui.get_object('image11').set_from_stock(gtk.STOCK_REMOVE, gtk.ICON_SIZE_MENU)
			self.gui.get_object('label7').set_text('Remove from list')
		elif downloader.stopDownload:
			self.gui.get_object('toolbutton1').set_sensitive(False)
			self.gui.get_object('toolbutton2').set_sensitive(True)
			self.gui.get_object('image11').set_from_stock(gtk.STOCK_REMOVE, gtk.ICON_SIZE_MENU)
			self.gui.get_object('label7').set_text('Remove from list')
		elif not downloader.size:
			self.gui.get_object('toolbutton1').set_sensitive(False)
			self.gui.get_object('toolbutton2').set_sensitive(True)
			self.gui.get_object('image11').set_from_stock(gtk.STOCK_REMOVE, gtk.ICON_SIZE_MENU)
			self.gui.get_object('label7').set_text('Remove from list')
		elif downloader.done == False:
			self.gui.get_object('toolbutton1').set_sensitive(False)
			self.gui.get_object('toolbutton2').set_sensitive(True)
			self.gui.get_object('image11').set_from_stock(gtk.STOCK_CANCEL, gtk.ICON_SIZE_MENU)
			self.gui.get_object('label7').set_text('Cancel download')
			
	def openDownload(self, obj, ofile=None):
		if not ofile:
			treeselection = self.gui.get_object('treeview2').get_selection()
			(model, iter) = treeselection.get_selected()
			ofile = model[iter][2]
		gext = os.path.splitext(ofile)
		ext = gext[1]
		command = None
		try:
			if ext in ['.mp3', '.aac', '.ogg']:
				command = [self.config.getSetting('General', 'audio_player', tools.getOpenWith(ext)[0])]
			elif ext in ['.mp4', '.mpg', '.mpeg', '.avi', '.ogv', '.flv']:
				command = [self.config.getSetting('General', 'video_player', tools.getOpenWith(ext)[0])]
			if command[0]:
				command.append(ofile)
				subprocess.Popen(command)
			else:
				command = tools.getOpenWith(ext)
				command.append(ofile)
				subprocess.Popen(command)
		except Exception, e:
			print e
			self.gui.get_object('statusImage').set_from_file('error.png')
			self.gui.get_object('statusLabel').set_text('Cannot open: no application associated with this file type.')
			self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
	
	def stopRemoveDownload(self, obj, event=None):
		treeselection = self.gui.get_object('treeview2').get_selection()
		(model, iter) = treeselection.get_selected()
		jobID = model[iter][4]
		downloader = self.downloaders[jobID]
		if not downloader.done:
			if downloader.stopDownload:
				model.remove(iter)
				self.downloaders.pop(jobID)
			elif not downloader.size:
				model.remove(iter)
				self.downloaders.pop(jobID)				
			else:
				downloader.cancel()
				self.gui.get_object('toolbutton2').set_sensitive(True)
				self.gui.get_object('image11').set_from_stock(gtk.STOCK_REMOVE, gtk.ICON_SIZE_MENU)
				self.gui.get_object('label7').set_text('Remove from list')
				model.set_value(iter, 0, gtk.gdk.pixbuf_new_from_file('error.png'))
		else:
			model.remove(iter)
			self.downloaders.pop(jobID)
		treeselection = self.gui.get_object('treeview2').get_selection()
		(model, iter) = treeselection.get_selected()
		if not iter:
			self.gui.get_object('toolbutton1').set_sensitive(False)
			self.gui.get_object('toolbutton2').set_sensitive(False)
	
	def setTags(self, name, saveAs, downloader):
		if not saveAs.endswith('.mp3'):
			return
		if ' - ' in name:
			(artist, title) = name.rsplit(' - ', 1)
		else:
			title = name
			artist = ''
		tag = eyeD3.Tag()
		tag.link(saveAs)
		tag.header.setVersion(eyeD3.ID3_V2_4)
		tag.setArtist(artist)
		tag.setTitle(title)
		tag.addComment('Downloaded with Pymaxe')
		if self.config.getSetting('General', 'download_covers', True):
			if osystem == 'WIN':
				now = datetime.datetime.now()
				tmp = os.environ.get('TMP') + '\\' + str(time.mktime(now.timetuple())) + str(random.randint(1, 999)) + '.png'
			else:
				now = datetime.datetime.now()
				tmp = '/tmp/' + str(time.mktime(now.timetuple())) + str(random.randint(1, 999)) + '.png'
			coverData = downloader.coverData
			if coverData:
				coverData.save(tmp)
				if open('cd_case.png', 'r').read() != open(tmp, 'r').read():
					pixbuf = tools.Image_to_GdkPixbuf(coverData)
					pixbuf.save(tmp, "png")
					tag.addImage(0x03, tmp)
		tag.setTextEncoding("\x03")
		tag.update()
		print 'tag updated'

	def fblike(self, obj, event=None):
		url = self.fileData['url']
		webbrowser.open_new('https://www.facebook.com/sharer/sharer.php?u=' + urllib.quote(url))
			
	def donate(self, obj, event=None):
		webbrowser.open('https://www.paypal.com/ro/cgi-bin/webscr?cmd=_flow&SESSION=7WNGJgHPkuV5-u5RQKh9orLUotbw15zWpKuAQXx7ueMgI4MXBA1z7cdSndC&dispatch=5885d80a13c0db1f8e263663d3faee8db2b24f7b84f1819390b7e2d9283d70f1')
	
	def facebook(self, obj, event=None):
		webbrowser.open('https://www.facebook.com/Pymaxe')
		
	def cursorPointer(self, obj, event=None):
		obj.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.HAND2))
		
	def cursorNormal(self, obj, event=None):
		obj.window.set_cursor(None)
	
	def hoverfb(self, obj, event=None):
		self.gui.get_object('image9').set_from_file('like_h.png')
	
	def unhoverfb(self, obj, event=None):
		self.gui.get_object('image9').set_from_file('like.png')
			
	def showAbout(self, obj):
		self.gui.get_object('label15').set_text('Pymaxe ' + str(version))
		self.gui.get_object('labelPymaxe').set_text('Using libPymaxe v.' + str(Pymaxe.version))
		self.gui.get_object('labelPython').set_text('Running using Python ' + sys.version)
		self.gui.get_object('aboutdialog').show()
		
	def hideAbout(self, obj, event=None):
		self.gui.get_object('aboutdialog').hide()
		return True
	
	def draw_background(self, obj, event):
		size = self.gui.get_object('mainw').get_size()
		pixbuf = gtk.gdk.pixbuf_new_from_file('pymaxe.png')
		obj.window.draw_pixbuf(obj.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0, 0, size[0] - 100, 17)
		
	def showDebug(self, obj, event=None):
		ErrorManager.show()
	
	def notifyOpened(self):
		if osystem == 'WIN':
			self.notificator = os.environ.get('TMP') + '\\' + '.pymaxe'
		else:
			self.notificator = '/tmp/' + '.pymaxe'
		open(self.notificator, 'w')
		
	def _error(self, tip, msg, tb):
		self.gui.get_object('statusImage').set_from_file('error.png')
		self.gui.get_object('statusLabel').set_text('Error...')
		self.gui.get_object('image1').set_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
		return False
		
	def quit(self, obj, event=None):
		self.stopSong(None)
		for x in self.downloaders:
			self.downloaders[x].cancel()
		if os.path.exists(self.notificator):
			os.remove(self.notificator)
		gtk.main_quit()
		os._exit(0)
		
if __name__ == "__main__":
	if not '--debug' in sys.argv:
		Main()
	else:
		try:
			Main()
		except:
			ErrorManager.exception()
